"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _plugins = require("./plugins");

var _getStats = _interopRequireDefault(require("./getStats"));

/**************************************************
 * Created by nanyuantingfeng on 23/08/2017 17:19.
 **************************************************/
var DEFAULT_PORT = 8080;
var DEFAULT_HOST = '0.0.0.0';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = Object.keys(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    oo[key] = typeof target === 'string' ? (0, _objectSpread2.default)({
      target: target
    }, options) : (0, _objectSpread2.default)({}, target, options);
  });
  return oo;
}

function parseStringProxy(proxy) {
  if (typeof proxy === 'string') {
    proxy = {
      '*': proxy
    };
  }

  return proxy;
}

function _default(_x, _x2) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(context, next) {
    var devServer, proxy, proxyOptions, plugins, DIRs, packageMap, proxyObj;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.devServer = {};
            context.proxy = {};
            context.proxyOptions = {
              changeOrigin: true
            };
            context.isDevServer = true;
            next();
            devServer = context.devServer, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins, DIRs = context.DIRs, packageMap = context.packageMap;
            proxyObj = parseProxyWithOptions((0, _objectSpread2.default)({}, parseStringProxy(packageMap.proxy), proxy), proxyOptions);
            context.webpackConfig.devServer = context.devServer = (0, _objectSpread2.default)({
              port: context.port || DEFAULT_PORT,
              host: DEFAULT_HOST,
              hot: true,
              hotOnly: true,
              contentBase: DIRs.root,
              // By default files from `contentBase` will not trigger a page reload.
              watchContentBase: true,
              // Enable gzip compression of generated files.
              compress: true,
              // WebpackDevServer is noisy by default so we emit custom message instead
              // by listening to the compiler events with `compiler.hooks[...].tap` calls above.
              quiet: false,
              disableHostCheck: true,
              clientLogLevel: 'none',
              overlay: false,
              headers: {
                'Access-Control-Allow-Origin': '*'
              },
              historyApiFallback: {
                // Paths with dots should still use the history fallback.
                // See https://github.com/facebook/create-react-app/issues/387.
                disableDotRule: true
              },
              proxy: proxyObj,
              stats: (0, _getStats.default)(false)
            }, devServer);
            plugins.push(new _plugins.HotModuleReplacementPlugin());

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _ref.apply(this, arguments);
}